SystemOrganization addCategory: #'Obj1-preguntados'!
SystemOrganization addCategory: 'Obj1-preguntados-model'!
SystemOrganization addCategory: 'Obj1-preguntados-specs'!

TestCase subclass: #TestCategoria
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-specs'!

!TestCategoria methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 11/18/2015 16:40'!
test_SiguientePreguntaFallaSiNoHayMasPreguntas
	|categoria pregunta|
	pregunta := Pregunta new.
	categoria := Categoria conPreguntas: { pregunta }.
	
	categoria siguientePregunta.

	self should: [categoria siguientePregunta] raise: Error whoseDescriptionIncludes: 'No quedan más preguntas en esta categoría' description: ''! !

!TestCategoria methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 11/18/2015 12:30'!
test_SiguientePreguntaQuitaLaPreguntaDeLaCategoria
	|categoria pregunta1 pregunta2 siguiente|
	pregunta1 := Pregunta new.
	pregunta2 := Pregunta new.
	categoria := Categoria conPreguntas: { pregunta1. pregunta2 }.
	
	siguiente := categoria siguientePregunta.
	
	self deny: (categoria preguntas includes: siguiente)! !

TestCase subclass: #TestPreguntados
	instanceVariableNames: 'jugadorDesafiante otroJugador partida preguntaHistoria respuestaCorrecta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-specs'!

!TestPreguntados methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 11/18/2015 16:45'!
setUp
	jugadorDesafiante := Jugador new.
	otroJugador := Jugador new.
	preguntaHistoria  := Pregunta 
		texto: '¿En qué año fue proscripto el Peronismo?'
		respuestaCorrecta: '1955'
		eIncorrecta: '1954'
		eIncorrecta: '1956'
		eIncorrecta: '1953'.
		
	Categoria conPreguntasDeHistoria: { preguntaHistoria }.
	partida := Partida con: jugadorDesafiante desafiaA: otroJugador yCategorias: Categoria todas! !

!TestPreguntados methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 11/18/2015 10:45'!
test_AlAvanzarEnUnTurnoEnEtapaGiroSeEstableceLaPregunta
	partida turnoActual avanzar.	
	self assert: partida turnoActual pregunta equals: preguntaHistoria! !

!TestPreguntados methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 11/18/2015 10:15'!
test_AlComenzarUnTurnoElMismoSeEncuentraEnLaEtapaDeGiroDeRuleta
	self assert: partida turnoActual etapa equals: Etapa giroDeRuleta! !

!TestPreguntados methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 11/18/2015 16:52'!
test_AlContestarBienLaPreguntaSeSumaUnPuntoAlTurno
	|turno|
	turno := partida turnoActual.
	turno avanzar.
	turno responderPreguntaCon: (preguntaHistoria respuestaCorrecta).
	
	self assert: turno puntaje equals: 1.! !

!TestPreguntados methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 11/18/2015 16:57'!
test_AlContestarMalLaPreguntaNoSumaPuntosAlTurno
	|turno|
	turno := partida turnoActual.
	turno avanzar.
	turno responderPreguntaCon: (preguntaHistoria algunaRespuestaIncorrecta).
	
	self assert: turno puntaje equals: 0.! !

!TestPreguntados methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 11/18/2015 10:14'!
test_AlIniciarseUnaPartidaElPrimerTurnoCorrespondeAlJugadorDesafiante
	self assert: partida turnoActual jugador equals: jugadorDesafiante! !

!TestPreguntados methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 11/19/2015 13:48'!
test_AlIniciarseUnaPartidaNoHayPreguntaActual
	self should: [partida turnoActual pregunta] raise: Error whoseDescriptionIncludes: 'Aún no se ha sorteado la pregunta' description: ''! !

!TestPreguntados methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 11/18/2015 10:14'!
test_UnJugadorPuedeIniciarUnaPartidaDesafiandoAOtroJugador
	self assert: partida estaIniciada

! !

Object subclass: #Categoria
	instanceVariableNames: 'preguntas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-model'!

Categoria class
	instanceVariableNames: 'historia'!

Categoria class
	instanceVariableNames: 'historia'!

!Categoria class methodsFor: 'initialization' stamp: 'FedericoAloi 11/18/2015 11:57'!
conPreguntas: unasPreguntas 
	^(self new) conPreguntas: unasPreguntas ; yourself! !

!Categoria class methodsFor: 'initialization' stamp: 'FedericoAloi 11/18/2015 11:57'!
conPreguntasDeHistoria: preguntasHistoria 
	historia := self conPreguntas: preguntasHistoria! !

!Categoria class methodsFor: 'public' stamp: 'FedericoAloi 11/18/2015 11:58'!
todas
	^{historia}! !

!Categoria methodsFor: 'initialization' stamp: 'FedericoAloi 11/18/2015 11:58'!
conPreguntas: unasPreguntas
	preguntas := Bag new.
	preguntas addAll: unasPreguntas! !

!Categoria methodsFor: 'initialization' stamp: 'FedericoAloi 11/18/2015 11:08'!
configurarPreguntas: unasPreguntas
	preguntas := Bag new
	preguntas addAll: unasPreguntas! !

!Categoria methodsFor: 'accessors' stamp: 'FedericoAloi 11/18/2015 12:24'!
preguntas
	^ preguntas! !

!Categoria methodsFor: 'public' stamp: 'FedericoAloi 11/18/2015 16:33'!
siguientePregunta
	|siguiente|
	self validarQuedanPreguntas.	
	siguiente := preguntas anyOne.
	preguntas remove: siguiente.
	^siguiente! !

!Categoria methodsFor: 'private' stamp: 'FedericoAloi 11/18/2015 16:39'!
validarQuedanPreguntas
	self preguntas ifEmpty: [self error: 'No quedan más preguntas en esta categoría']! !

Object subclass: #Etapa
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-model'!

Etapa class
	instanceVariableNames: 'giroDeRuleta responderPregunta elegirPersonaje'!

!Etapa commentStamp: '<historical>' prior: 0!
Soy una etapa de juego. Denoto el estado del juego en un momento dado.!

Etapa class
	instanceVariableNames: 'giroDeRuleta responderPregunta elegirPersonaje'!

!Etapa class methodsFor: 'accesing' stamp: 'ArielAlvarez 10/28/2015 01:58'!
giroDeRuleta
	^giroDeRuleta ! !

!Etapa class methodsFor: 'accesing' stamp: 'ArielAlvarez 10/28/2015 01:58'!
initialize
	super initialize.
	giroDeRuleta := EtapaGiroDeRuleta new.
	! !

Etapa subclass: #EtapaGiroDeRuleta
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-model'!

!EtapaGiroDeRuleta commentStamp: '<historical>' prior: 0!
Soy la etapa en la cual el jugador debe girar la ruleta!

!EtapaGiroDeRuleta methodsFor: 'public' stamp: 'FedericoAloi 11/18/2015 12:05'!
avanzarEn: unTurno 
	unTurno pregunta: (self sortearPreguntaPara: unTurno)! !

!EtapaGiroDeRuleta methodsFor: 'private' stamp: 'FedericoAloi 11/18/2015 12:13'!
sortearCategoriaPara: unTurno 
	^unTurno categorias anyOne! !

!EtapaGiroDeRuleta methodsFor: 'private' stamp: 'FedericoAloi 11/18/2015 12:07'!
sortearPreguntaPara: unTurno 
	^(self sortearCategoriaPara: unTurno) siguientePregunta! !

Object subclass: #Jugador
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-model'!

!Jugador commentStamp: '<historical>' prior: 0!
Soy un jugador del juego Preguntados!

!Jugador methodsFor: 'public' stamp: 'ArielAlvarez 10/27/2015 21:24'!
desafiaA: otroJugador 
	^Partida newConDesafiante: self yDesafiado: otroJugador! !

Object subclass: #Partida
	instanceVariableNames: 'desafiante desafiado turno categorias'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-model'!

!Partida commentStamp: '<historical>' prior: 0!
Soy una partida de preguntados!

!Partida class methodsFor: 'initialization' stamp: 'FedericoAloi 11/18/2015 12:01'!
con: desafiante desafiaA: contrincante yCategorias: categorias
	^(self new) inicializarConDesafiante: desafiante contra: contrincante yCategorias: categorias ; yourself! !

!Partida methodsFor: 'accessors' stamp: 'FedericoAloi 11/18/2015 12:09'!
categorias
	^ categorias! !

!Partida methodsFor: 'public' stamp: 'ArielAlvarez 10/27/2015 21:25'!
estaIniciada
	^true! !

!Partida methodsFor: 'initialization' stamp: 'FedericoAloi 11/18/2015 12:09'!
inicializarConDesafiante: unJugador contra: otroJugador yCategorias: unasCategorias
	desafiante := unJugador.
	desafiado := otroJugador.
	categorias := Bag new.
	categorias addAll: unasCategorias.
	turno := (Turno new) inicializarConActual: desafiante ySiguiente: desafiado enPartida: self.
	^self! !

!Partida methodsFor: 'public' stamp: 'ArielAlvarez 10/27/2015 21:40'!
jugador
	self shouldBeImplemented.! !

!Partida methodsFor: 'public' stamp: 'ArielAlvarez 10/27/2015 21:38'!
siguienteTurno
	self shouldBeImplemented.! !

!Partida methodsFor: 'public' stamp: 'AlvarezAriel 11/17/2015 22:36'!
turnoActual
	^turno
! !

Object subclass: #Pregunta
	instanceVariableNames: 'texto respuestas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-model'!

!Pregunta class methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 11/18/2015 16:48'!
texto: unTexto respuestaCorrecta: textoCorrecta eIncorrecta: textoIncorrecta1 eIncorrecta: textoIncorrecta2 eIncorrecta: textoIncorrecta3
	|pregunta|
	pregunta := (self new) conTexto: unTexto yRespuestas: 
		{ RespuestaCorrecta conTexto: textoCorrecta },
		({ textoCorrecta. textoIncorrecta1. textoIncorrecta2. textoIncorrecta3 } collect: [ :t | RespuestaIncorrecta conTexto: t ]).
		
	^pregunta! !

!Pregunta methodsFor: 'accessors' stamp: 'FedericoAloi 11/18/2015 16:58'!
algunaRespuestaIncorrecta
	^respuestas last! !

!Pregunta methodsFor: 'initialization' stamp: 'FedericoAloi 11/18/2015 16:50'!
conTexto: unTexto yRespuestas: unasRespuestas
	texto := unTexto.
	respuestas := OrderedCollection new.
	respuestas addAll: unasRespuestas ! !

!Pregunta methodsFor: 'accessors' stamp: 'FedericoAloi 11/18/2015 16:47'!
respuestaCorrecta
	^respuestas first! !

Object subclass: #Respuesta
	instanceVariableNames: 'texto'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-model'!

!Respuesta class methodsFor: 'initialization' stamp: 'FedericoAloi 11/18/2015 11:00'!
conTexto: unTexto
	^(self new) conTexto: unTexto ; yourself! !

!Respuesta methodsFor: 'initialization' stamp: 'FedericoAloi 11/18/2015 11:00'!
conTexto: unTexto
	texto := unTexto ! !

Respuesta subclass: #RespuestaCorrecta
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-model'!

!RespuestaCorrecta methodsFor: 'public' stamp: 'FedericoAloi 11/18/2015 16:55'!
fueElegidaEn: unTurno 
	unTurno preguntaRespondidaCorrectamente! !

Respuesta subclass: #RespuestaIncorrecta
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-model'!

!RespuestaIncorrecta methodsFor: 'public' stamp: 'FedericoAloi 11/18/2015 16:59'!
fueElegidaEn: unTurno 
	unTurno preguntaRespondidaIncorrectamente ! !

Object subclass: #Turno
	instanceVariableNames: 'jugadorActual jugadorSiguiente etapa partida pregunta puntaje'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-model'!

!Turno commentStamp: '<historical>' prior: 0!
Soy un turno en una partida. !

!Turno methodsFor: 'public' stamp: 'FedericoAloi 11/18/2015 12:04'!
avanzar
	etapa avanzarEn: self! !

!Turno methodsFor: 'accessors' stamp: 'FedericoAloi 11/18/2015 12:08'!
categorias
	^partida categorias! !

!Turno methodsFor: 'accesing' stamp: 'ArielAlvarez 10/28/2015 01:44'!
etapa
	^etapa! !

!Turno methodsFor: 'public' stamp: 'FedericoAloi 11/18/2015 16:55'!
incrementarPuntaje
	puntaje := puntaje + 1! !

!Turno methodsFor: 'initialization' stamp: 'FedericoAloi 11/18/2015 12:08'!
inicializarConActual: aJugador ySiguiente: aJugador2 enPartida: unaPartida
	jugadorActual := aJugador.
	jugadorSiguiente := aJugador2.
	partida := unaPartida.
	etapa := Etapa giroDeRuleta.
	^self! !

!Turno methodsFor: 'initialization' stamp: 'FedericoAloi 11/18/2015 16:56'!
initialize
	puntaje := 0! !

!Turno methodsFor: 'public' stamp: 'ArielAlvarez 10/27/2015 21:44'!
jugador
	^jugadorActual ! !

!Turno methodsFor: 'accessors' stamp: 'FedericoAloi 11/19/2015 13:49'!
pregunta
	^ pregunta ifNil: [ self error: 'Aún no se ha sorteado la pregunta' ]! !

!Turno methodsFor: 'accessors' stamp: 'FedericoAloi 11/18/2015 12:16'!
pregunta: unaPregunta 
	pregunta := unaPregunta! !

!Turno methodsFor: 'public' stamp: 'FedericoAloi 11/18/2015 16:55'!
preguntaRespondidaCorrectamente
	self incrementarPuntaje! !

!Turno methodsFor: 'public' stamp: 'FedericoAloi 11/18/2015 17:00'!
preguntaRespondidaIncorrectamente
	! !

!Turno methodsFor: 'accessors' stamp: 'FedericoAloi 11/18/2015 16:56'!
puntaje
	^ puntaje! !

!Turno methodsFor: 'public' stamp: 'FedericoAloi 11/18/2015 16:54'!
responderPreguntaCon: unaRespuesta
	unaRespuesta fueElegidaEn: self! !
Etapa initialize!
